import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
public class Test extends JFrame {
	 JButton b = new JButton("Click to add label");
	 Panel p1 = new Panel();
	 Panel p2 = new Panel();
	 Panel center = new Panel(new GridLayout(1,2));
	 Label label = new Label("Add to change the size");
	 boolean added = false;
	 public Test() {
		  center.add(p1);
		  center.add(p2);
		  getContentPane().add(b, BorderLayout.WEST);
		  getContentPane().add(center, BorderLayout.CENTER);
		  p1.add(new Button("anything"));
		  p2.add(new Button("anything"));
		  //p1.setBorder(BorderFactory.createLineBorder(Color.red, 2));
		  //p2.setBorder(BorderFactory.createLineBorder(Color.green, 2));
		  //pack();
		  setSize(400, 200);
		  System.out.println("p1: width=" + getWidth()+ ", height=" + getHeight());   
		  System.out.println("p2: width=" + getWidth()+ ", height=" + getHeight());
		  p1.addComponentListener(new ComponentAdapter() {
					 public void componentResized(ComponentEvent e) {
						  System.out.println("p1: width=" + p1.getWidth()+
													", height=" + p1.getHeight());
					 }
				});
		  p2.addComponentListener(new ComponentAdapter() {
					 public void componentResized(ComponentEvent e) {
						  System.out.println("p2: width=" + p2.getWidth()+
													", height=" + p2.getHeight());
					 }
				});
		  
		  b.addActionListener(new ActionListener() {
					 public void actionPerformed(ActionEvent e) {
						  if (added) { getContentPane().remove(label); }
						  else { getContentPane().add(label, BorderLayout.SOUTH); }
						  added = !added;
						  validate();
					 }
				});
		  
	 }  
	 public static void main(String[] args) {
		  JFrame f = new Test();
		  f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		  f.setVisible(true);
	 }	 
}
