//==============================================================================
// ImagePanel
//------------------------------------------------------------------------------
//
// A panel... that displays an image. 
//
//==============================================================================
//
//345678901234567890123456789012345678901234567890123456789012345678901234567890
//       1         2         3         4         5         6         7         8

import java.awt.*;
import java.io.*;

//------------------------------------------------------------------------------
// * ImagePanel
//------------------------------------------------------------------------------
//
public class ImagePanel extends Panel{
	Image mImage;

//------------------------------------------------------
// * ImagePanel
//------------------------------------------------------
//	
public ImagePanel(Image theImage){
	mImage = theImage;
	invalidate();
	repaint();
}

//------------------------------------------------------
// * SetImage
//------------------------------------------------------
//	
public void SetImage(Image theImage){
	mImage = theImage;
	invalidate();
	repaint();
}

	 public Dimension minimumSize(){
		  return (new Dimension(320,240));
	 }

	 public Dimension preferredSize(){
		  return (new Dimension(320,240));
	 }



//------------------------------------------------------
// * paint
//------------------------------------------------------
//
public void paint(Graphics g){
	if (mImage != null){
		g.drawImage(mImage,0,0,this);
	}
	else{
		System.out.println("No image is available for ImagePanel");
	}
}
	
}//---| End ImagePanel |----------------------------------------------------
